/*************************************************** 
  www.buydisplay.com
 ****************************************************/

#include "TFTM040-1.h"
#include <limits.h>
#include "pins_arduino.h"
#include "wiring_private.h"
 #include "Arduino.h"

//   All output pins are configurable.
LCD::LCD(int8_t cs, int8_t dc, int8_t rst, int8_t wr, int8_t rd, int8_t d0, 
int8_t d1, int8_t d2, int8_t d3, int8_t d4, int8_t d5, int8_t d6, int8_t d7) : ERGFX(LCD_TFTWIDTH, LCD_TFTHEIGHT) {
  _cs   = cs;
  _dc   = dc;
  _rst  = rst;
  _wr   = wr;
  _rd   = rd;
  _d0   = d0;
  _d1   = d1;
  _d2   = d2;
  _d3   = d3;
  _d4   = d4;
  _d5   = d5;
  _d6   = d6;
  _d7   = d7;


}


void LCD::writebyte(uint8_t c) {


  if(c&0x01)*d0port |= d0pinmask;   else *d0port &= ~d0pinmask;
  if(c&0x02)*d1port |= d1pinmask;   else *d1port &= ~d1pinmask;
  if(c&0x04)*d2port |= d2pinmask;   else *d2port &= ~d2pinmask;
  if(c&0x08)*d3port |= d3pinmask;   else *d3port &= ~d3pinmask;
  if(c&0x10)*d4port |= d4pinmask;   else *d4port &= ~d4pinmask;
  if(c&0x20)*d5port |= d5pinmask;   else *d5port &= ~d5pinmask;
  if(c&0x40)*d6port |= d6pinmask;   else *d6port &= ~d6pinmask;
  if(c&0x80)*d7port |= d7pinmask;   else *d7port &= ~d7pinmask;

  *wrport &= ~wrpinmask;
  //digitalWrite(_wr, LOW);
 
 // *wrport |= wrpinmask;
  digitalWrite(_wr, HIGH);
}


void LCD::writecommand(uint16_t c) {
  *dcport &=  ~dcpinmask;
 // digitalWrite(_dc, LOW);
  *csport &= ~cspinmask;
 // digitalWrite(_cs, LOW);
  writebyte(c >> 8);
  writebyte(c);
  *csport |= cspinmask;
 // digitalWrite(_cs, HIGH);
}


void LCD::writedata(uint8_t d) {
  *dcport |=  dcpinmask;
 // digitalWrite(_dc, HIGH);

  *csport &= ~cspinmask;
 // digitalWrite(_cs, LOW);
  
   writebyte(d);

 // digitalWrite(_cs, HIGH);
  *csport |= cspinmask;
} 


void LCD::writecommandword(uint8_t d) {
  *dcport |=  dcpinmask;
 // digitalWrite(_dc, HIGH);

  *csport &= ~cspinmask;
 // digitalWrite(_cs, LOW);
  
  writebyte(0);
  writebyte(d);

 // digitalWrite(_cs, HIGH);
  *csport |= cspinmask;
} 


void LCD::begin(void) {
  if (_rst > 0) {
    pinMode(_rst, OUTPUT);
    digitalWrite(_rst, LOW);
  }

  pinMode(_dc, OUTPUT);
  pinMode(_cs, OUTPUT);
  pinMode(_wr, OUTPUT);
  pinMode(_rd, OUTPUT);
  pinMode(_d0, OUTPUT);
  pinMode(_d1, OUTPUT);
  pinMode(_d2, OUTPUT);
  pinMode(_d3, OUTPUT);
  pinMode(_d4, OUTPUT);
  pinMode(_d5, OUTPUT);
  pinMode(_d6, OUTPUT);
  pinMode(_d7, OUTPUT);

  csport    = portOutputRegister(digitalPinToPort(_cs));
  cspinmask = digitalPinToBitMask(_cs);
  dcport    = portOutputRegister(digitalPinToPort(_dc));
  dcpinmask = digitalPinToBitMask(_dc);
  wrport    = portOutputRegister(digitalPinToPort(_wr));
  wrpinmask = digitalPinToBitMask(_wr);
  rdport    = portOutputRegister(digitalPinToPort(_rd));
  rdpinmask = digitalPinToBitMask(_rd);
  d0port    = portOutputRegister(digitalPinToPort(_d0));
  d0pinmask = digitalPinToBitMask(_d0);
  d1port    = portOutputRegister(digitalPinToPort(_d1));
  d1pinmask = digitalPinToBitMask(_d1);
  d2port    = portOutputRegister(digitalPinToPort(_d2));
  d2pinmask = digitalPinToBitMask(_d2);
  d3port    = portOutputRegister(digitalPinToPort(_d3));
  d3pinmask = digitalPinToBitMask(_d3);
  d4port    = portOutputRegister(digitalPinToPort(_d4));
  d4pinmask = digitalPinToBitMask(_d4);
  d5port    = portOutputRegister(digitalPinToPort(_d5));
  d5pinmask = digitalPinToBitMask(_d5);
  d6port    = portOutputRegister(digitalPinToPort(_d6));
  d6pinmask = digitalPinToBitMask(_d6);
  d7port    = portOutputRegister(digitalPinToPort(_d7));
  d7pinmask = digitalPinToBitMask(_d7);

   //digitalWrite(_cs, HIGH);
  *csport |=  cspinmask;
  // digitalWrite(_dc, HIGH);
  *dcport |=  dcpinmask;
  // digitalWrite(_wr, HIGH);
  *wrport |=  wrpinmask;
  // digitalWrite(_rd, HIGH);
  *rdport |=  rdpinmask;
  // digitalWrite(_d0, HIGH);
  *d0port |=  d0pinmask;
  // digitalWrite(_d1, HIGH);
  *d1port |=  d1pinmask;
  // digitalWrite(_d2, HIGH);
  *d2port |=  d2pinmask;
  // digitalWrite(_d3, HIGH);
  *d3port |=  d3pinmask;
  // digitalWrite(_d4, HIGH);
  *d4port |=  d4pinmask;
  // digitalWrite(_d5, HIGH);
  *d5port |=  d5pinmask;
  // digitalWrite(_d6, HIGH);
  *d6port |=  d6pinmask;
  // digitalWrite(_d7, HIGH);
  *d7port |=  d7pinmask;



 

  // toggle RST low to reset
  if (_rst > 0) {
    digitalWrite(_rst, HIGH);
    delay(5);
    digitalWrite(_rst, LOW);
    delay(20);
    digitalWrite(_rst, HIGH);
    delay(150);
  }





   //35510h	
	writecommand(0xF000);writecommandword(0x55);
	writecommand(0xF001);writecommandword(0xAA);
	writecommand(0xF002);writecommandword(0x52);
	writecommand(0xF003);writecommandword(0x08);
	writecommand(0xF004);writecommandword(0x01);
	
	//#AVDD Set AVDD 5.2V
	writecommand(0xB000);writecommandword(0x0D);
	writecommand(0xB001);writecommandword(0x0D);
	writecommand(0xB002);writecommandword(0x0D);
	
	//#AVDD ratio
	writecommand(0xB600);writecommandword(0x34);
	writecommand(0xB601);writecommandword(0x34);
	writecommand(0xB602);writecommandword(0x34);
	 
	//#AVEE  -5.2V
	writecommand(0xB100);writecommandword(0x0D);
	writecommand(0xB101);writecommandword(0x0D);
	writecommand(0xB102);writecommandword(0x0D);
	
	//#AVEE ratio
	writecommand(0xB700);writecommandword(0x34);
	writecommand(0xB701);writecommandword(0x34);
	writecommand(0xB702);writecommandword(0x34);
	
	//#VCL  -2.5V
	writecommand(0xB200);writecommandword(0x00);
	writecommand(0xB201);writecommandword(0x00);
	writecommand(0xB202);writecommandword(0x00);
	
	//#VCL ratio
	writecommand(0xB800);writecommandword(0x24);
	writecommand(0xB801);writecommandword(0x24);
	writecommand(0xB802);writecommandword(0x24); 
	
	//#VGH  15V
	writecommand(0xBF00);writecommandword(0x01);
	writecommand(0xB300);writecommandword(0x0F);
	writecommand(0xB301);writecommandword(0x0F);
	writecommand(0xB302);writecommandword(0x0F);
	
	//#VGH  ratio
	writecommand(0xB900);writecommandword(0x34);
	writecommand(0xB901);writecommandword(0x34);
	writecommand(0xB902);writecommandword(0x34); 
	
	//#VGL_REG  -10V
	writecommand(0xB500);writecommandword(0x08);
	writecommand(0xB500);writecommandword(0x08);
	writecommand(0xB501);writecommandword(0x08);
	writecommand(0xC200);writecommandword(0x03);
	
	//#VGLX  ratio
	writecommand(0xBA00);writecommandword(0x24);
	writecommand(0xBA01);writecommandword(0x24);
	writecommand(0xBA02);writecommandword(0x24);
	
	//#VGMP/VGSP 4.5V/0V
	writecommand(0xBC00);writecommandword(0x00);
	writecommand(0xBC01);writecommandword(0x78);
	writecommand(0xBC02);writecommandword(0x00);
	
	//#VGMN/VGSN -4.5V/0V
	writecommand(0xBD00);writecommandword(0x00);
	writecommand(0xBD01);writecommandword(0x78);
	writecommand(0xBD02);writecommandword(0x00);
	
	//#VCOM  -1.325V
	writecommand(0xBE00);writecommandword(0x00);
	writecommand(0xBE01);writecommandword(0x89);//69
	
	 //Gamma Setting	 
	writecommand(0xD100);writecommandword(0x00);
	writecommand(0xD101);writecommandword(0x2D);
	writecommand(0xD102);writecommandword(0x00);
	writecommand(0xD103);writecommandword(0x2E);
	writecommand(0xD104);writecommandword(0x00); 
	writecommand(0xD105);writecommandword(0x32);
	writecommand(0xD106);writecommandword(0x00);
	writecommand(0xD107);writecommandword(0x44);
	writecommand(0xD108);writecommandword(0x00);
	writecommand(0xD109);writecommandword(0x53);
	writecommand(0xD10A);writecommandword(0x00);
	writecommand(0xD10B);writecommandword(0x88);
	writecommand(0xD10C);writecommandword(0x00);
	writecommand(0xD10D);writecommandword(0xB6);
	writecommand(0xD10E);writecommandword(0x00);
	writecommand(0xD10F);writecommandword(0xF3);	//
	writecommand(0xD110);writecommandword(0x01);
	writecommand(0xD111);writecommandword(0x22);
	writecommand(0xD112);writecommandword(0x01);
	writecommand(0xD113);writecommandword(0x64);
	writecommand(0xD114);writecommandword(0x01);
	writecommand(0xD115);writecommandword(0x92);
	writecommand(0xD116);writecommandword(0x01);
	writecommand(0xD117);writecommandword(0xD4);
	writecommand(0xD118);writecommandword(0x02);	
	writecommand(0xD119);writecommandword(0x07);
	writecommand(0xD11A);writecommandword(0x02);
	writecommand(0xD11B);writecommandword(0x08);
	writecommand(0xD11C);writecommandword(0x02);
	writecommand(0xD11D);writecommandword(0x34);
	writecommand(0xD11E);writecommandword(0x02);
	writecommand(0xD11F);writecommandword(0x5F); //
	writecommand(0xD120);writecommandword(0x02);
	writecommand(0xD121);writecommandword(0x78);
	writecommand(0xD122);writecommandword(0x02);
	writecommand(0xD123);writecommandword(0x94);
	writecommand(0xD124);writecommandword(0x02);
	writecommand(0xD125);writecommandword(0xA6);
	writecommand(0xD126);writecommandword(0x02);
	writecommand(0xD127);writecommandword(0xBB);
	writecommand(0xD128);writecommandword(0x02); 
	writecommand(0xD129);writecommandword(0xCA);
	writecommand(0xD12A);writecommandword(0x02);
	writecommand(0xD12B);writecommandword(0xDB);
	writecommand(0xD12C);writecommandword(0x02);
	writecommand(0xD12D);writecommandword(0xE8);
	writecommand(0xD12E);writecommandword(0x02);
	writecommand(0xD12F);writecommandword(0xF9); //
	writecommand(0xD130);writecommandword(0x03); 
	writecommand(0xD131);writecommandword(0x1F);
	writecommand(0xD132);writecommandword(0x03);
	writecommand(0xD133);writecommandword(0x7F);
			 
	writecommand(0xD200);writecommandword(0x00);
	writecommand(0xD201);writecommandword(0x2D);
	writecommand(0xD202);writecommandword(0x00);
	writecommand(0xD203);writecommandword(0x2E);
	writecommand(0xD204);writecommandword(0x00); 
	writecommand(0xD205);writecommandword(0x32);
	writecommand(0xD206);writecommandword(0x00);
	writecommand(0xD207);writecommandword(0x44);
	writecommand(0xD208);writecommandword(0x00);
	writecommand(0xD209);writecommandword(0x53);
	writecommand(0xD20A);writecommandword(0x00);
	writecommand(0xD20B);writecommandword(0x88);
	writecommand(0xD20C);writecommandword(0x00);
	writecommand(0xD20D);writecommandword(0xB6);
	writecommand(0xD20E);writecommandword(0x00);
	writecommand(0xD20F);writecommandword(0xF3);	//
	writecommand(0xD210);writecommandword(0x01);
	writecommand(0xD211);writecommandword(0x22);
	writecommand(0xD212);writecommandword(0x01);
	writecommand(0xD213);writecommandword(0x64);
	writecommand(0xD214);writecommandword(0x01);
	writecommand(0xD215);writecommandword(0x92);
	writecommand(0xD216);writecommandword(0x01);
	writecommand(0xD217);writecommandword(0xD4);
	writecommand(0xD218);writecommandword(0x02);	
	writecommand(0xD219);writecommandword(0x07);
	writecommand(0xD21A);writecommandword(0x02);
	writecommand(0xD21B);writecommandword(0x08);
	writecommand(0xD21C);writecommandword(0x02);
	writecommand(0xD21D);writecommandword(0x34);
	writecommand(0xD21E);writecommandword(0x02);
	writecommand(0xD21F);writecommandword(0x5F); //
	writecommand(0xD220);writecommandword(0x02);
	writecommand(0xD221);writecommandword(0x78);
	writecommand(0xD222);writecommandword(0x02);
	writecommand(0xD223);writecommandword(0x94);
	writecommand(0xD224);writecommandword(0x02);
	writecommand(0xD225);writecommandword(0xA6);
	writecommand(0xD226);writecommandword(0x02);
	writecommand(0xD227);writecommandword(0xBB);
	writecommand(0xD228);writecommandword(0x02); 
	writecommand(0xD229);writecommandword(0xCA);
	writecommand(0xD22A);writecommandword(0x02);
	writecommand(0xD22B);writecommandword(0xDB);
	writecommand(0xD22C);writecommandword(0x02);
	writecommand(0xD22D);writecommandword(0xE8);
	writecommand(0xD22E);writecommandword(0x02);
	writecommand(0xD22F);writecommandword(0xF9); //
	writecommand(0xD230);writecommandword(0x03); 
	writecommand(0xD231);writecommandword(0x1F);
	writecommand(0xD232);writecommandword(0x03);
	writecommand(0xD233);writecommandword(0x7F);
		 
	writecommand(0xD300);writecommandword(0x00);
	writecommand(0xD301);writecommandword(0x2D);
	writecommand(0xD302);writecommandword(0x00);
	writecommand(0xD303);writecommandword(0x2E);
	writecommand(0xD304);writecommandword(0x00); 
	writecommand(0xD305);writecommandword(0x32);
	writecommand(0xD306);writecommandword(0x00);
	writecommand(0xD307);writecommandword(0x44);
	writecommand(0xD308);writecommandword(0x00);
	writecommand(0xD309);writecommandword(0x53);
	writecommand(0xD30A);writecommandword(0x00);
	writecommand(0xD30B);writecommandword(0x88);
	writecommand(0xD30C);writecommandword(0x00);
	writecommand(0xD30D);writecommandword(0xB6);
	writecommand(0xD30E);writecommandword(0x00);
	writecommand(0xD30F);writecommandword(0xF3);	//
	writecommand(0xD310);writecommandword(0x01);
	writecommand(0xD311);writecommandword(0x22);
	writecommand(0xD312);writecommandword(0x01);
	writecommand(0xD313);writecommandword(0x64);
	writecommand(0xD314);writecommandword(0x01);
	writecommand(0xD315);writecommandword(0x92);
	writecommand(0xD316);writecommandword(0x01);
	writecommand(0xD317);writecommandword(0xD4);
	writecommand(0xD318);writecommandword(0x02);	
	writecommand(0xD319);writecommandword(0x07);
	writecommand(0xD31A);writecommandword(0x02);
	writecommand(0xD31B);writecommandword(0x08);
	writecommand(0xD31C);writecommandword(0x02);
	writecommand(0xD31D);writecommandword(0x34);
	writecommand(0xD31E);writecommandword(0x02);
	writecommand(0xD31F);writecommandword(0x5F); //
	writecommand(0xD320);writecommandword(0x02);
	writecommand(0xD321);writecommandword(0x78);
	writecommand(0xD322);writecommandword(0x02);
	writecommand(0xD323);writecommandword(0x94);
	writecommand(0xD324);writecommandword(0x02);
	writecommand(0xD325);writecommandword(0xA6);
	writecommand(0xD326);writecommandword(0x02);
	writecommand(0xD327);writecommandword(0xBB);
	writecommand(0xD328);writecommandword(0x02); 
	writecommand(0xD329);writecommandword(0xCA);
	writecommand(0xD32A);writecommandword(0x02);
	writecommand(0xD32B);writecommandword(0xDB);
	writecommand(0xD32C);writecommandword(0x02);
	writecommand(0xD32D);writecommandword(0xE8);
	writecommand(0xD32E);writecommandword(0x02);
	writecommand(0xD32F);writecommandword(0xF9); //
	writecommand(0xD330);writecommandword(0x03); 
	writecommand(0xD331);writecommandword(0x1F);
	writecommand(0xD332);writecommandword(0x03);
	writecommand(0xD333);writecommandword(0x7F);
		 
	writecommand(0xD400);writecommandword(0x00);
	writecommand(0xD401);writecommandword(0x2D);
	writecommand(0xD402);writecommandword(0x00);
	writecommand(0xD403);writecommandword(0x2E);
	writecommand(0xD404);writecommandword(0x00); 
	writecommand(0xD405);writecommandword(0x32);
	writecommand(0xD406);writecommandword(0x00);
	writecommand(0xD407);writecommandword(0x44);
	writecommand(0xD408);writecommandword(0x00);
	writecommand(0xD409);writecommandword(0x53);
	writecommand(0xD40A);writecommandword(0x00);
	writecommand(0xD40B);writecommandword(0x88);
	writecommand(0xD40C);writecommandword(0x00);
	writecommand(0xD40D);writecommandword(0xB6);
	writecommand(0xD40E);writecommandword(0x00);
	writecommand(0xD40F);writecommandword(0xF3);	//
	writecommand(0xD410);writecommandword(0x01);
	writecommand(0xD411);writecommandword(0x22);
	writecommand(0xD412);writecommandword(0x01);
	writecommand(0xD413);writecommandword(0x64);
	writecommand(0xD414);writecommandword(0x01);
	writecommand(0xD415);writecommandword(0x92);
	writecommand(0xD416);writecommandword(0x01);
	writecommand(0xD417);writecommandword(0xD4);
	writecommand(0xD418);writecommandword(0x02);	
	writecommand(0xD419);writecommandword(0x07);
	writecommand(0xD41A);writecommandword(0x02);
	writecommand(0xD41B);writecommandword(0x08);
	writecommand(0xD41C);writecommandword(0x02);
	writecommand(0xD41D);writecommandword(0x34);
	writecommand(0xD41E);writecommandword(0x02);
	writecommand(0xD41F);writecommandword(0x5F); //
	writecommand(0xD420);writecommandword(0x02);
	writecommand(0xD421);writecommandword(0x78);
	writecommand(0xD422);writecommandword(0x02);
	writecommand(0xD423);writecommandword(0x94);
	writecommand(0xD424);writecommandword(0x02);
	writecommand(0xD425);writecommandword(0xA6);
	writecommand(0xD426);writecommandword(0x02);
	writecommand(0xD427);writecommandword(0xBB);
	writecommand(0xD428);writecommandword(0x02); 
	writecommand(0xD429);writecommandword(0xCA);
	writecommand(0xD42A);writecommandword(0x02);
	writecommand(0xD42B);writecommandword(0xDB);
	writecommand(0xD42C);writecommandword(0x02);
	writecommand(0xD42D);writecommandword(0xE8);
	writecommand(0xD42E);writecommandword(0x02);
	writecommand(0xD42F);writecommandword(0xF9); //
	writecommand(0xD430);writecommandword(0x03); 
	writecommand(0xD431);writecommandword(0x1F);
	writecommand(0xD432);writecommandword(0x03);
	writecommand(0xD433);writecommandword(0x7F);
		 
	writecommand(0xD500);writecommandword(0x00);
	writecommand(0xD501);writecommandword(0x2D);
	writecommand(0xD502);writecommandword(0x00);
	writecommand(0xD503);writecommandword(0x2E);
	writecommand(0xD504);writecommandword(0x00); 
	writecommand(0xD505);writecommandword(0x32);
	writecommand(0xD506);writecommandword(0x00);
	writecommand(0xD507);writecommandword(0x44);
	writecommand(0xD508);writecommandword(0x00);
	writecommand(0xD509);writecommandword(0x53);
	writecommand(0xD50A);writecommandword(0x00);
	writecommand(0xD50B);writecommandword(0x88);
	writecommand(0xD50C);writecommandword(0x00);
	writecommand(0xD50D);writecommandword(0xB6);
	writecommand(0xD50E);writecommandword(0x00);
	writecommand(0xD50F);writecommandword(0xF3);	//
	writecommand(0xD510);writecommandword(0x01);
	writecommand(0xD511);writecommandword(0x22);
	writecommand(0xD512);writecommandword(0x01);
	writecommand(0xD513);writecommandword(0x64);
	writecommand(0xD514);writecommandword(0x01);
	writecommand(0xD515);writecommandword(0x92);
	writecommand(0xD516);writecommandword(0x01);
	writecommand(0xD517);writecommandword(0xD4);
	writecommand(0xD518);writecommandword(0x02);	
	writecommand(0xD519);writecommandword(0x07);
	writecommand(0xD51A);writecommandword(0x02);
	writecommand(0xD51B);writecommandword(0x08);
	writecommand(0xD51C);writecommandword(0x02);
	writecommand(0xD51D);writecommandword(0x34);
	writecommand(0xD51E);writecommandword(0x02);
	writecommand(0xD51F);writecommandword(0x5F); //
	writecommand(0xD520);writecommandword(0x02);
	writecommand(0xD521);writecommandword(0x78);
	writecommand(0xD522);writecommandword(0x02);
	writecommand(0xD523);writecommandword(0x94);
	writecommand(0xD524);writecommandword(0x02);
	writecommand(0xD525);writecommandword(0xA6);
	writecommand(0xD526);writecommandword(0x02);
	writecommand(0xD527);writecommandword(0xBB);
	writecommand(0xD528);writecommandword(0x02); 
	writecommand(0xD529);writecommandword(0xCA);
	writecommand(0xD52A);writecommandword(0x02);
	writecommand(0xD52B);writecommandword(0xDB);
	writecommand(0xD52C);writecommandword(0x02);
	writecommand(0xD52D);writecommandword(0xE8);
	writecommand(0xD52E);writecommandword(0x02);
	writecommand(0xD52F);writecommandword(0xF9); //
	writecommand(0xD530);writecommandword(0x03); 
	writecommand(0xD531);writecommandword(0x1F);
	writecommand(0xD532);writecommandword(0x03);
	writecommand(0xD533);writecommandword(0x7F);
		 
	writecommand(0xD600);writecommandword(0x00);
	writecommand(0xD601);writecommandword(0x2D);
	writecommand(0xD602);writecommandword(0x00);
	writecommand(0xD603);writecommandword(0x2E);
	writecommand(0xD604);writecommandword(0x00); 
	writecommand(0xD605);writecommandword(0x32);
	writecommand(0xD606);writecommandword(0x00);
	writecommand(0xD607);writecommandword(0x44);
	writecommand(0xD608);writecommandword(0x00);
	writecommand(0xD609);writecommandword(0x53);
	writecommand(0xD60A);writecommandword(0x00);
	writecommand(0xD60B);writecommandword(0x88);
	writecommand(0xD60C);writecommandword(0x00);
	writecommand(0xD60D);writecommandword(0xB6);
	writecommand(0xD60E);writecommandword(0x00);
	writecommand(0xD60F);writecommandword(0xF3);	//
	writecommand(0xD610);writecommandword(0x01);
	writecommand(0xD611);writecommandword(0x22);
	writecommand(0xD612);writecommandword(0x01);
	writecommand(0xD613);writecommandword(0x64);
	writecommand(0xD614);writecommandword(0x01);
	writecommand(0xD615);writecommandword(0x92);
	writecommand(0xD616);writecommandword(0x01);
	writecommand(0xD617);writecommandword(0xD4);
	writecommand(0xD618);writecommandword(0x02);	
	writecommand(0xD619);writecommandword(0x07);
	writecommand(0xD61A);writecommandword(0x02);
	writecommand(0xD61B);writecommandword(0x08);
	writecommand(0xD61C);writecommandword(0x02);
	writecommand(0xD61D);writecommandword(0x34);
	writecommand(0xD61E);writecommandword(0x02);
	writecommand(0xD61F);writecommandword(0x5F); //
	writecommand(0xD620);writecommandword(0x02);
	writecommand(0xD621);writecommandword(0x78);
	writecommand(0xD622);writecommandword(0x02);
	writecommand(0xD623);writecommandword(0x94);
	writecommand(0xD624);writecommandword(0x02);
	writecommand(0xD625);writecommandword(0xA6);
	writecommand(0xD626);writecommandword(0x02);
	writecommand(0xD627);writecommandword(0xBB);
	writecommand(0xD628);writecommandword(0x02); 
	writecommand(0xD629);writecommandword(0xCA);
	writecommand(0xD62A);writecommandword(0x02);
	writecommand(0xD62B);writecommandword(0xDB);
	writecommand(0xD62C);writecommandword(0x02);
	writecommand(0xD62D);writecommandword(0xE8);
	writecommand(0xD62E);writecommandword(0x02);
	writecommand(0xD62F);writecommandword(0xF9); //
	writecommand(0xD630);writecommandword(0x03); 
	writecommand(0xD631);writecommandword(0x1F);
	writecommand(0xD632);writecommandword(0x03);
	writecommand(0xD633);writecommandword(0x7F);
	 
	//#LV2 Page 0 enable
	writecommand(0xF000);writecommandword(0x55);
	writecommand(0xF001);writecommandword(0xAA);
	writecommand(0xF002);writecommandword(0x52);
	writecommand(0xF003);writecommandword(0x08);
	writecommand(0xF004);writecommandword(0x00); 
	
	//#DISPLAY CONTROL
	writecommand(0xB100);writecommandword(0xCC);
	writecommand(0xB101);writecommandword(0x00); 


	{writecommand(0xB500);writecommandword(0x50);}
		
	//#SOURCE HOLD TIME
	writecommand(0xB600);writecommandword(0x05);
	
	//Set Gate EQ     
	writecommand(0xB700);writecommandword(0x70); 
	writecommand(0xB701);writecommandword(0x70);
	
	//#Source EQ control (Mode 2)
	writecommand(0xB800);writecommandword(0x01);
	writecommand(0xB801);writecommandword(0x03);
	writecommand(0xB802);writecommandword(0x03);
	writecommand(0xB803);writecommandword(0x03);
	
	//#INVERSION MODE
	writecommand(0xBC00);writecommandword(0x02);
	writecommand(0xBC01);writecommandword(0x00);	
	writecommand(0xBC02);writecommandword(0x00); 
	
	//#Timing control
	writecommand(0xC900);writecommandword(0xD0);   
	writecommand(0xC901);writecommandword(0x02);
	writecommand(0xC902);writecommandword(0x50);
	writecommand(0xC903);writecommandword(0x50); 
	writecommand(0xC904);writecommandword(0x50); 
	

   writecommand(0x3500);   writecommandword(0x00); 


  writecommand(0x3A00);   writecommandword(0x55); //Data format 16-Bits
  writecommand(0x3600);   writecommandword(0xA0);   




        writecommand(0x1100);    //Exit Sleep 

        delay(120); 		

        writecommand(0x2900);    //Display on 
   

}


void LCD::setAddrWindow(uint16_t x0, uint16_t y0, uint16_t x1,
 uint16_t y1) {
 
	writecommand(0x2A00);  writecommandword(x0>>8);
	writecommand(0x2A01);  writecommandword(x0);
	writecommand(0x2A02);  writecommandword(x1>>8);
	writecommand(0x2A03);  writecommandword(x1);
	writecommand(0x2B00);  writecommandword(y0>>8);
	writecommand(0x2B01);  writecommandword(y0);
	writecommand(0x2B02);  writecommandword(y1>>8);
	writecommand(0x2B03);  writecommandword(y1);


  writecommand(0x2C00); // write to RAM
}


void LCD::pushColor(uint16_t color) {
 
  //digitalWrite(_dc, HIGH);
  *dcport |=  dcpinmask;
  //digitalWrite(_cs, LOW);
  *csport &= ~cspinmask;

  writebyte(color >> 8);
  writebyte(color);

  *csport |= cspinmask;
  //digitalWrite(_cs, HIGH);

}

void LCD::drawPixel(int16_t x, int16_t y, uint16_t color) {

  if((x < 0) ||(x >= _width) || (y < 0) || (y >= _height)) return;


  setAddrWindow(x,y,x+1,y+1);

  //digitalWrite(_dc, HIGH);
  *dcport |=  dcpinmask;
  //digitalWrite(_cs, LOW);
  *csport &= ~cspinmask;

  writebyte(color >> 8);
  writebyte(color);

  *csport |= cspinmask;
  //digitalWrite(_cs, HIGH);
 
}


void LCD::drawFastVLine(int16_t x, int16_t y, int16_t h,
 uint16_t color) {

  // Rudimentary clipping
  if((x >= _width) || (y >= _height)) return;

  if((y+h-1) >= _height) 
    h = _height-y;

 
  setAddrWindow(x, y, x, y+h-1);

  uint8_t hi = color >> 8, lo = color;

  *dcport |=  dcpinmask;
  //digitalWrite(_dc, HIGH);
  *csport &= ~cspinmask;
  //digitalWrite(_cs, LOW);

  while (h--) {
    writebyte(hi);
    writebyte(lo);
  }
  *csport |= cspinmask;
  //digitalWrite(_cs, HIGH);
 
}


void LCD::drawFastHLine(int16_t x, int16_t y, int16_t w,
  uint16_t color) {

  // Rudimentary clipping
  if((x >= _width) || (y >= _height)) return;
  if((x+w-1) >= _width)  w = _width-x;

  setAddrWindow(x, y, x+w-1, y);

  uint8_t hi = color >> 8, lo = color;
  *dcport |=  dcpinmask;
  *csport &= ~cspinmask;
  //digitalWrite(_dc, HIGH);
  //digitalWrite(_cs, LOW);
  while (w--) {
    writebyte(hi);
    writebyte(lo);
  }
  *csport |= cspinmask;
  //digitalWrite(_cs, HIGH);
 
}

void LCD::fillScreen(uint16_t color) {
  fillRect(0, 0,  _width, _height, color);

}

// fill a rectangle
void LCD::fillRect(int16_t x, int16_t y, int16_t w, int16_t h,
  uint16_t color) {

  // rudimentary clipping (drawChar w/big text requires this)
  if((x >= _width) || (y >= _height)) return;
  if((x + w - 1) >= _width)  w = _width  - x;
  if((y + h - 1) >= _height) h = _height - y;

  setAddrWindow(x, y, x+w-1, y+h-1);

  uint8_t hi = color >> 8, lo = color;

  *dcport |=  dcpinmask;
  //digitalWrite(_dc, HIGH);
  *csport &= ~cspinmask;
  //digitalWrite(_cs, LOW);

  for(y=h; y>0; y--) {
    for(x=w; x>0; x--) {

     writebyte(hi);
     writebyte(lo);
  
    }
  }
  //digitalWrite(_cs, HIGH);
  *csport |= cspinmask;
 
}

void LCD::bmp16(uint16_t x, uint16_t y, const uint8_t *pBmp, uint16_t chWidth, uint16_t chHeight) {
    uint16_t i, j;
    uint16_t hwColor;
     uint8_t hi , lo ;

  // rudimentary clipping (drawChar w/big text requires this)
  if((x >= _width) || (y >= _height)) return;
  if((x + chWidth - 1) >= _width)  chWidth = _width  - x;
  if((y + chHeight - 1) >= _height) chHeight = _height - y;


    setAddrWindow(x, y, x+chWidth-1, y+chHeight-1);

  *dcport |=  dcpinmask;
  //digitalWrite(_dc, HIGH);
  *csport &= ~cspinmask;
  //digitalWrite(_cs, LOW);

    for(j = 0; j < chHeight; j++) {
        for(i = 0; i < chWidth; i++) {
          hi= pgm_read_byte(pBmp++);lo= pgm_read_byte(pBmp++);
          writebyte(hi);
          writebyte(lo);
        }
    }
   //digitalWrite(_cs, HIGH);
  *csport |= cspinmask;
  
}

// Pass 8-bit (each) R,G,B, get back 16-bit packed color
uint16_t LCD::color565(uint8_t r, uint8_t g, uint8_t b) {
  return ((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3);
}

 

